Subject: Re: [PATCH] ixgbe: Introduce new 10GbE driver for Intel 82598 based PCI Express adapters...

From: Arjan van de Ven <[email-masked]>
Date: Mon, 02 Jul 2007 07:41:54 -0700

Jeff Garzik wrote:
> It's simple logic:  using machine integers are the easiest for the 
> compiler to Do The Right Thing, the easiest way to eliminate endian 
> problems, the easiest way for programmers to read and understand struct 
> alignment.

using integers pure is obviously natural..
but using integers and then manually doing bit masking yourself... 
that's not fundamentally better than what the compiler can do.

yes bitfields are hard for not-1-bit cases and for cases where you 
mimick hardware layouts. neither is the case in this code.
The code gets actually harder to read for the feature flags if you 
don't use bitfields....  so unless the code is really worse (and so 
far I've not seen that, but I'll investigate more when I get to work), 
I think it's fair to use single-bit, non-packed bitfields for them...